open Expr

let ps = print_string
let p x = ps x;print_newline()

(* "astuce": on utilise le ou logique avec le registre 0 *)
let store r k =
  let sr = string_of_int r in
  let sk = string_of_int k in
    p ("ORI R"^sr^" R0 "^sk^"   /* R"^sr^" <- "^sk^" */")

let rec engendre = function
  | Const k -> store 1 k
  | Add(e1,e2) -> begin
	engendre e1;      (* evaluation de e1, le resultat est dans R1 *)
	p "PSH R1 R30 4";   (* on stocke le resultat en haut de la pile *)
	engendre e2;      (* evaluation de e2, idem *)
	p "POP R29 R30 4";  (* on stocke le haut de la pile dans R29 *)
	p "ADD R1 R1 R29   /* R1 <- R1 + R29 */"; 
    end
  | Mul(e1,e2) -> begin
	engendre e1;
	p "PSH R1 R30 4";  
	engendre e2;
	p "POP R29 R30 4";   
	p "MUL R1 R1 R29   /* R1 <- R1 * R29 */";
    end

let retour_chariot () =
  begin
    store 1 10;
    p "SYSCALL R1 0 6 /* retour a la ligne */"
  end

let entete () =
  p "SYSCALL R30 0 13 /* R30 est initalise en haut de la memoire */";
  p "/* le calcul demarre */"

let concl () =
  begin   (* avant de finir, on affiche le resultat *)
    p "/* ---- fin des calculs: on affiche le resultat ---- */";
    p "SYSCALL R1 0 7  /*  SYS_IO_WR_INT: afficher le contenu de 1 */";
    retour_chariot ();
    p "SYSCALL R0 0 19 /* SYS_EXIT */"
  end

let evalue e =
  begin
    entete ();
    engendre e;
    concl ()
  end
